﻿Imports GrapeCity.Spreadsheet
Imports GrapeCity.CalcEngine

'Creating and defining the external variable
Public Class TextBoxExternalVariable
    Inherits ExternalVariable
    Private _textBox As TextBox
    Private _asInput As Boolean
    Public Sub New(ByVal textBox As TextBox, ByVal asInput As Boolean)
        _textBox = textBox
        If asInput Then
            AddHandler textBox.TextChanged, AddressOf TextBox_TextChanged
        End If
    End Sub
    Private Sub TextBox_TextChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dirty()
    End Sub
    Protected Overrides Function OnDirtying() As Boolean
        Return Not _asInput
    End Function
    Protected Overrides Sub OnDirtied()
        Refresh()
    End Sub
    Protected Overrides Sub EvaluateCore(ByVal context As IEvaluationContext, ByVal result As IValue)
        Dim text As String = _textBox.Text
        Dim dblValue As Double = Nothing
        If Not String.IsNullOrEmpty(text) AndAlso Double.TryParse(text, dblValue) Then
            result.SetValue(dblValue)
        Else
            result.SetValue(text)
        End If
    End Sub
    Public Sub Refresh()
        If Not _asInput Then
            _textBox.Text = Me.Value.GetText()
        End If
    End Sub
End Class